Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerhg.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerhg.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerhg.F90	(revision 8486)
@@ -10,21 +10,21 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3' :                                 LIM3 sea-ice model
+   !!   'key_lim3'                                       LIM3 sea-ice model
    !!----------------------------------------------------------------------
    !!    ice_rhg      : computes ice velocities
    !!    ice_rhg_init : initialization and namelist read
    !!----------------------------------------------------------------------
-   USE phycst           ! physical constants
-   USE dom_oce          ! ocean space and time domain
-   USE ice              ! LIM-3 variables
-   USE icerhg_evp       ! EVP rheology
-   USE icectl           ! control prints
-   USE icevar
+   USE phycst         ! physical constants
+   USE dom_oce        ! ocean space and time domain
+   USE ice            ! sea-ice: variables
+   USE icerhg_evp     ! sea-ice: EVP rheology
+   USE icectl         ! sea-ice: control prints
+   USE icevar         ! sea-ice: operations
    !
-   USE lbclnk           ! lateral boundary conditions - MPP exchanges
-   USE lib_mpp          ! MPP library
-   USE in_out_manager   ! I/O manager
-   USE lib_fortran      ! glob_sum
-   USE timing           ! Timing
+   USE lbclnk         ! lateral boundary conditions - MPP exchanges
+   USE lib_mpp        ! MPP library
+   USE in_out_manager ! I/O manager
+   USE lib_fortran    ! glob_sum
+   USE timing         ! Timing
 
    IMPLICIT NONE
@@ -37,5 +37,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: icerhg.F90 8378 2017-07-26 13:55:59Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -53,28 +53,28 @@
       !!                      - shear, divergence and delta (shear_i, divu_i, delta_i)
       !!--------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt     ! number of iteration
+      INTEGER, INTENT(in) ::   kt     ! ice time step
       !!
-      INTEGER  :: jl ! dummy loop indices
+      INTEGER  ::   jl   ! dummy loop indices
       REAL(wp) :: zvi_b, zsmv_b, zei_b, zfs_b, zfw_b, zft_b 
       !!--------------------------------------------------------------------
-
+      !
       IF( nn_timing == 1 )  CALL timing_start('icerhg')
-
+      !
       IF( kt == nit000 .AND. lwp ) THEN
          WRITE(numout,*)
-         WRITE(numout,*)'icerhg'
-         WRITE(numout,*)'~~~~~~'
+         WRITE(numout,*)'ice_rhg : sea-ice rheology'
+         WRITE(numout,*)'~~~~~~~~'
       ENDIF
 
-      CALL ice_var_agg(1)   ! aggregate ice categories
+      CALL ice_var_agg(1)           ! -- aggregate ice categories
       !
-      ! conservation test
-      IF( ln_limdiachk ) CALL ice_cons_hsm(0, 'icerhg', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-      
-      ! Landfast ice parameterization: define max bottom friction
-      tau_icebfr(:,:) = 0._wp
-      IF( ln_landfast ) THEN
+      !                             ! -- conservation test
+      IF( ln_limdiachk )   CALL ice_cons_hsm(0, 'icerhg', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      !                      
+      IF( ln_landfast ) THEN        ! -- Landfast ice parameterization: define max bottom friction
          DO jl = 1, jpl
-            WHERE( ht_i(:,:,jl) > ht_n(:,:) * rn_gamma )  tau_icebfr(:,:) = tau_icebfr(:,:) + a_i(:,:,jl) * rn_icebfr
+            WHERE( ht_i(:,:,jl) > ht_n(:,:) * rn_gamma )   ;   tau_icebfr(:,:) = tau_icebfr(:,:) + a_i(:,:,jl) * rn_icebfr
+            ELSEWHERE                                      ;   tau_icebfr(:,:) = 0._wp
+            END WHERE
          END DO
       ENDIF
@@ -83,25 +83,22 @@
       ! Rheology (ice dynamics)
       ! -----------------------   
-      IF( nn_limdyn /= 0 ) THEN                          ! -- Ice dynamics
-
+      IF( nn_limdyn /= 0 ) THEN     ! -- Ice dynamics
+         !
          CALL ice_rhg_evp( stress1_i, stress2_i, stress12_i, u_ice, v_ice, shear_i, divu_i, delta_i )
-
-      ELSE
-
-         u_ice(:,:) = rn_uice * umask(:,:,1)             !     or prescribed velocity
+         !
+      ELSE                          ! -- prescribed uniform velocity
+         !
+         u_ice(:,:) = rn_uice * umask(:,:,1)
          v_ice(:,:) = rn_vice * vmask(:,:,1)
          !!CALL RANDOM_NUMBER(u_ice(:,:))
          !!CALL RANDOM_NUMBER(v_ice(:,:))
-
+         !
       ENDIF
       !
-      ! conservation test
-      IF( ln_limdiachk ) CALL ice_cons_hsm(1, 'icerhg', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
-
-      ! Control prints
-      IF( ln_ctl )       CALL ice_prt3D( 'icerhg' )
+      !                                                   !- conservation test
+      IF( ln_limdiachk   )   CALL ice_cons_hsm(1, 'icerhg', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      IF( ln_ctl         )   CALL ice_prt3D  ('icerhg')   !- Control prints
+      IF( nn_timing == 1 )   CALL timing_stop('icerhg')   !- timing
       !
-      IF( nn_timing == 1 )  CALL timing_stop('icerhg')
-
    END SUBROUTINE ice_rhg
 
@@ -119,54 +116,62 @@
       !! ** input   :   Namelist namicedyn
       !!-------------------------------------------------------------------
-      INTEGER  ::   ios                 ! Local integer output status for namelist read
-      NAMELIST/namicedyn/ nn_limadv, nn_limadv_ord,                                &
-         &                nn_icestr, rn_pe_rdg, rn_pstar, rn_crhg, ln_icestr_bvf,  &
-         &                rn_ishlat, rn_cio, rn_creepl, rn_ecc,                    &
-         &                nn_nevp, rn_relast, ln_landfast, rn_gamma, rn_icebfr, rn_lfrelax
+      INTEGER ::   ios   ! Local integer output status for namelist read
+      !!
+      NAMELIST/namicedyn/ nn_limadv  , nn_limadv_ord,                                       &
+         &                nn_icestr  , rn_pe_rdg, rn_pstar , rn_crhg, ln_icestr_bvf     ,   &
+         &                rn_ishlat  , rn_cio   , rn_creepl, rn_ecc , nn_nevp, rn_relast,   &
+         &                ln_landfast, rn_gamma , rn_icebfr, rn_lfrelax
       !!-------------------------------------------------------------------
-
-      REWIND( numnam_ice_ref )              ! Namelist namicedyn in reference namelist : Ice dynamics
+      !
+      REWIND( numnam_ice_ref )         ! Namelist namicedyn in reference namelist : Ice dynamics
       READ  ( numnam_ice_ref, namicedyn, IOSTAT = ios, ERR = 901)
 901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicedyn in reference namelist', lwp )
-
-      REWIND( numnam_ice_cfg )              ! Namelist namicedyn in configuration namelist : Ice dynamics
+      !
+      REWIND( numnam_ice_cfg )         ! Namelist namicedyn in configuration namelist : Ice dynamics
       READ  ( numnam_ice_cfg, namicedyn, IOSTAT = ios, ERR = 902 )
 902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicedyn in configuration namelist', lwp )
       IF(lwm) WRITE ( numoni, namicedyn )
-      
-      IF(lwp) THEN                        ! control print
+      !
+      IF(lwp) THEN                     ! control print
          WRITE(numout,*)
          WRITE(numout,*) 'ice_rhg_init : ice parameters for ice dynamics '
          WRITE(numout,*) '~~~~~~~~~~~~'
-         ! limtrp
-         WRITE(numout,*)'    choose the advection scheme (-1=Prather, 0=Ulimate-Macho)   nn_limadv     = ', nn_limadv 
-         WRITE(numout,*)'    choose the order of the scheme (if ultimate)                nn_limadv_ord = ', nn_limadv_ord  
-         ! icerdgrft
-         WRITE(numout,*)'    ice strength parameterization (0=Hibler 1=Rothrock)         nn_icestr     = ', nn_icestr 
-         WRITE(numout,*)'    Ratio of ridging work to PotEner change in ridging          rn_pe_rdg     = ', rn_pe_rdg 
-         WRITE(numout,*) '   first bulk-rheology parameter                               rn_pstar      = ', rn_pstar
-         WRITE(numout,*) '   second bulk-rhelogy parameter                               rn_crhg       = ', rn_crhg
-         WRITE(numout,*)'    Including brine volume in ice strength comp.                ln_icestr_bvf = ', ln_icestr_bvf
-         ! icerhg_evp
-         WRITE(numout,*) '   lateral boundary condition for sea ice dynamics             rn_ishlat     = ', rn_ishlat
-         WRITE(numout,*) '   drag coefficient for oceanic stress                         rn_cio        = ', rn_cio
-         WRITE(numout,*) '   creep limit                                                 rn_creepl     = ', rn_creepl
-         WRITE(numout,*) '   eccentricity of the elliptical yield curve                  rn_ecc        = ', rn_ecc
-         WRITE(numout,*) '   number of iterations for subcycling                         nn_nevp       = ', nn_nevp
-         WRITE(numout,*) '   ratio of elastic timescale over ice time step               rn_relast     = ', rn_relast
-         WRITE(numout,*) '   Landfast: param (T or F)                                    ln_landfast   = ', ln_landfast
-         WRITE(numout,*) '      T: fraction of ocean depth that ice must reach           rn_gamma      = ', rn_gamma
-         WRITE(numout,*) '      T: maximum bottom stress per unit area of contact        rn_icebfr     = ', rn_icebfr
-         WRITE(numout,*) '      T: relax time scale (s-1) to reach static friction       rn_lfrelax    = ', rn_lfrelax
+         WRITE(numout,*) '   Namelist namicedyn'
+         WRITE(numout,*) '      advection scheme for ice transport (limtrp)'
+         WRITE(numout,*) '         type of advection scheme (-1=Prather, 0=Ulimate-Macho)   nn_limadv     = ', nn_limadv 
+         WRITE(numout,*) '         order of the scheme for Ultimate-Macho case              nn_limadv_ord = ', nn_limadv_ord
+         WRITE(numout,*) '      ridging/rafting (icerdgrft)'
+         WRITE(numout,*) '         ice strength parameterization (0=Hibler 1=Rothrock)      nn_icestr     = ', nn_icestr 
+         WRITE(numout,*) '         Ratio of ridging work to PotEner change in ridging       rn_pe_rdg     = ', rn_pe_rdg 
+         WRITE(numout,*) '         1st bulk-rheology parameter                              rn_pstar      = ', rn_pstar
+         WRITE(numout,*) '         2nd bulk-rhelogy parameter                               rn_crhg       = ', rn_crhg
+         WRITE(numout,*) '         brine volume included in ice strength computation        ln_icestr_bvf = ', ln_icestr_bvf
+         WRITE(numout,*) '      rheology EVP (icerhg_evp)'
+         WRITE(numout,*) '         lateral boundary condition for sea ice dynamics          rn_ishlat     = ', rn_ishlat
+         WRITE(numout,*) '         drag coefficient for oceanic stress                      rn_cio        = ', rn_cio
+         WRITE(numout,*) '         creep limit                                              rn_creepl     = ', rn_creepl
+         WRITE(numout,*) '         eccentricity of the elliptical yield curve               rn_ecc        = ', rn_ecc
+         WRITE(numout,*) '         number of iterations for subcycling                      nn_nevp       = ', nn_nevp
+         WRITE(numout,*) '         ratio of elastic timescale over ice time step            rn_relast     = ', rn_relast
+         WRITE(numout,*) '      Landfast: param (T or F)                                    ln_landfast   = ', ln_landfast
+         WRITE(numout,*) '         fraction of ocean depth that ice must reach              rn_gamma      = ', rn_gamma
+         WRITE(numout,*) '         maximum bottom stress per unit area of contact           rn_icebfr     = ', rn_icebfr
+         WRITE(numout,*) '         relax time scale (s-1) to reach static friction          rn_lfrelax    = ', rn_lfrelax
       ENDIF
       !
-      IF     (      rn_ishlat == 0.                ) THEN   ;   IF(lwp) WRITE(numout,*) '   ice lateral  free-slip '
-      ELSEIF (      rn_ishlat == 2.                ) THEN   ;   IF(lwp) WRITE(numout,*) '   ice lateral  no-slip '
-      ELSEIF ( 0. < rn_ishlat .AND. rn_ishlat < 2. ) THEN   ;   IF(lwp) WRITE(numout,*) '   ice lateral  partial-slip '
-      ELSEIF ( 2. < rn_ishlat                      ) THEN   ;   IF(lwp) WRITE(numout,*) '   ice lateral  strong-slip '
+      IF     (      rn_ishlat == 0.                ) THEN   ;   IF(lwp) WRITE(numout,*) '   ===>>>   ice lateral  free-slip'
+      ELSEIF (      rn_ishlat == 2.                ) THEN   ;   IF(lwp) WRITE(numout,*) '   ===>>>   ice lateral  no-slip'
+      ELSEIF ( 0. < rn_ishlat .AND. rn_ishlat < 2. ) THEN   ;   IF(lwp) WRITE(numout,*) '   ===>>>   ice lateral  partial-slip'
+      ELSEIF ( 2. < rn_ishlat                      ) THEN   ;   IF(lwp) WRITE(numout,*) '   ===>>>   ice lateral  strong-slip'
       ENDIF
+      !
+      IF( .NOT. ln_landfast )   tau_icebfr(:,:) = 0._wp     ! NO Landfast ice : set to zero one for all
       !
    END SUBROUTINE ice_rhg_init
 
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option         Empty module          NO LIM-3 sea-ice model
+   !!----------------------------------------------------------------------
 #endif 
 
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerhg_evp.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerhg_evp.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerhg_evp.F90	(revision 8486)
@@ -45,5 +45,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: icerhg_evp.F90 8378 2017-07-26 13:55:59Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -386,6 +386,5 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1               
-
-               ! U points
+               !                   !--- U points
                zfU(ji,jj) = 0.5_wp * ( ( zs1(ji+1,jj) - zs1(ji,jj) ) * e2u(ji,jj)                                             &
                   &                  + ( zs2(ji+1,jj) * e2t(ji+1,jj) * e2t(ji+1,jj) - zs2(ji,jj) * e2t(ji,jj) * e2t(ji,jj)    &
@@ -394,6 +393,6 @@
                   &                    ) * 2._wp * r1_e1u(ji,jj)                                                              &
                   &                  ) * r1_e1e2u(ji,jj)
-
-               ! V points
+                  !
+                  !                !--- V points
                zfV(ji,jj) = 0.5_wp * ( ( zs1(ji,jj+1) - zs1(ji,jj) ) * e1v(ji,jj)                                             &
                   &                  - ( zs2(ji,jj+1) * e1t(ji,jj+1) * e1t(ji,jj+1) - zs2(ji,jj) * e1t(ji,jj) * e1t(ji,jj)    &
@@ -402,13 +401,13 @@
                   &                    ) * 2._wp * r1_e2v(ji,jj)                                                              &
                   &                  ) * r1_e1e2v(ji,jj)
-
-               ! u_ice at V point
+                  !
+                  !                !--- u_ice at V point
                u_iceV(ji,jj) = 0.5_wp * ( ( u_ice(ji,jj  ) + u_ice(ji-1,jj  ) ) * e2t(ji,jj+1)     &
                   &                     + ( u_ice(ji,jj+1) + u_ice(ji-1,jj+1) ) * e2t(ji,jj  ) ) * z1_e2t0(ji,jj) * vmask(ji,jj,1)
-               
-               ! v_ice at U point
+                  !
+                  !                !--- v_ice at U point
                v_iceU(ji,jj) = 0.5_wp * ( ( v_ice(ji  ,jj) + v_ice(ji  ,jj-1) ) * e1t(ji+1,jj)     &
                   &                     + ( v_ice(ji+1,jj) + v_ice(ji+1,jj-1) ) * e1t(ji  ,jj) ) * z1_e1t0(ji,jj) * umask(ji,jj,1)
-
+               !
             END DO
          END DO
@@ -417,32 +416,30 @@
          !  Bouillon et al. 2013 (eq 47-48) => unstable unless alpha, beta are chosen wisely and large nn_nevp
          !  Bouillon et al. 2009 (eq 34-35) => stable
-         IF( MOD(jter,2) .EQ. 0 ) THEN ! even iterations
-            
+         IF( MOD(jter,2) == 0 ) THEN ! even iterations
+            !
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1
-
-                  ! tau_io/(v_oce - v_ice)
+                     !                 !--- tau_io/(v_oce - v_ice)
                   zTauO = zaV(ji,jj) * zrhoco * SQRT( ( v_ice (ji,jj) - v_oce (ji,jj) ) * ( v_ice (ji,jj) - v_oce (ji,jj) )  &
                      &                              + ( u_iceV(ji,jj) - u_oceV(ji,jj) ) * ( u_iceV(ji,jj) - u_oceV(ji,jj) ) )
-
-                  ! Ocean-to-Ice stress
+                     !                 !--- Ocean-to-Ice stress
                   ztauy_oi(ji,jj) = zTauO * ( v_oce(ji,jj) - v_ice(ji,jj) )
-
-                  ! tau_bottom/v_ice
+                     !
+                     !                 !--- tau_bottom/v_ice
                   zvel  = MAX( zepsi, SQRT( v_ice(ji,jj) * v_ice(ji,jj) + u_iceV(ji,jj) * u_iceV(ji,jj) ) )
                   zTauB = - tau_icebfr(ji,jj) / zvel
-
-                  ! Coriolis at V-points (energy conserving formulation)
+                     !
+                     !                 !--- Coriolis at V-points (energy conserving formulation)
                   zCory(ji,jj)  = - 0.25_wp * r1_e2v(ji,jj) *  &
                      &    ( zmf(ji,jj  ) * ( e2u(ji,jj  ) * u_ice(ji,jj  ) + e2u(ji-1,jj  ) * u_ice(ji-1,jj  ) )  &
                      &    + zmf(ji,jj+1) * ( e2u(ji,jj+1) * u_ice(ji,jj+1) + e2u(ji-1,jj+1) * u_ice(ji-1,jj+1) ) )
-
-                  ! Sum of external forces (explicit solution) = F + tau_ia + Coriolis + spg + tau_io
+                     !
+                     !                 !--- Sum of external forces (explicit solution) = F + tau_ia + Coriolis + spg + tau_io
                   zTauE = zfV(ji,jj) + zTauV_ia(ji,jj) + zCory(ji,jj) + zspgV(ji,jj) + ztauy_oi(ji,jj)
-
-                  ! landfast switch => 0 = static friction ; 1 = sliding friction
+                     !
+                     !                 !--- landfast switch => 0 = static friction ; 1 = sliding friction
                   rswitch = 1._wp - MIN( 1._wp, ABS( SIGN( 1._wp, ztauE - tau_icebfr(ji,jj) ) - SIGN( 1._wp, zTauE ) ) )
-                  
-                  ! ice velocity using implicit formulation (cf Madec doc & Bouillon 2009)
+                     !
+                     !                 !--- ice velocity using implicit formulation (cf Madec doc & Bouillon 2009)
                   v_ice(ji,jj) = ( (           rswitch   * ( zmV_t(ji,jj) * v_ice(ji,jj)                   &  ! previous velocity
                      &                                     + zTauE + zTauO * v_ice(ji,jj)                  &  ! F + tau_ia + Coriolis + spg + tau_io(only ocean part)
@@ -451,13 +448,14 @@
                      &             ) * zswitchV(ji,jj) + v_oce(ji,jj) * ( 1._wp - zswitchV(ji,jj) )        &  ! v_ice = v_oce if mass < zmmin
                      &           ) * zmaskV(ji,jj)
+                     !
                   ! Bouillon 2013
                   !!v_ice(ji,jj) = ( zmV_t(ji,jj) * ( zbeta * v_ice(ji,jj) + v_ice_b(ji,jj) )                  &
                   !!   &           + zfV(ji,jj) + zCory(ji,jj) + zTauV_ia(ji,jj) + zTauO * v_oce(ji,jj) + zspgV(ji,jj)  &
                   !!   &           ) / MAX( zmV_t(ji,jj) * ( zbeta + 1._wp ) + zTauO - zTauB, zepsi ) * zswitchV(ji,jj)
-
+                  !
                END DO
             END DO
             CALL lbc_lnk( v_ice, 'V', -1. )
-            
+            !
 #if defined key_agrif
 !!            CALL agrif_interp_lim3( 'V', jter, nn_nevp )
@@ -465,5 +463,5 @@
 #endif
             IF( ln_bdy ) CALL bdy_ice_dyn( 'V' )
-
+            !
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1
@@ -505,5 +503,5 @@
             END DO
             CALL lbc_lnk( u_ice, 'U', -1. )
-            
+            !
 #if defined key_agrif
 !!            CALL agrif_interp_lim3( 'U', jter, nn_nevp )
@@ -511,7 +509,7 @@
 #endif
             IF( ln_bdy ) CALL bdy_ice_dyn( 'U' )
-
+            !
          ELSE ! odd iterations
-
+            !
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1
@@ -553,5 +551,5 @@
             END DO
             CALL lbc_lnk( u_ice, 'U', -1. )
-            
+            !
 #if defined key_agrif
 !!            CALL agrif_interp_lim3( 'U', jter, nn_nevp )
@@ -559,5 +557,5 @@
 #endif
             IF( ln_bdy ) CALL bdy_ice_dyn( 'U' )
-
+            !
             DO jj = 2, jpjm1
                DO ji = fs_2, fs_jpim1
@@ -599,5 +597,5 @@
             END DO
             CALL lbc_lnk( v_ice, 'V', -1. )
-            
+            !
 #if defined key_agrif
 !!            CALL agrif_interp_lim3( 'V', jter, nn_nevp )
@@ -605,5 +603,5 @@
 #endif
             IF( ln_bdy ) CALL bdy_ice_dyn( 'V' )
-
+            !
          ENDIF
          
@@ -675,5 +673,8 @@
       ! 5) SIMIP diagnostics
       !------------------------------------------------------------------------------!
-                           
+
+!!gm  encapsulate with a flag (iom_use of the variable or better a flag defined one for all testing if one of the
+!!    diag is output.  NB the diag_...  are should only be ALLOCATED if the flag is true !
+
       DO jj = 2, jpjm1
          DO ji = 2, jpim1
@@ -714,13 +715,13 @@
 
       CALL lbc_lnk_multi(   diag_sig1   , 'T',  1., diag_sig2   , 'T',  1.,   &
-                 &          diag_dssh_dx, 'U', -1., diag_dssh_dy, 'V', -1.,   &
-                 &          diag_corstrx, 'U', -1., diag_corstry, 'V', -1.,   & 
-                 &          diag_intstrx, 'U', -1., diag_intstry, 'V', -1.    )
+         &                  diag_dssh_dx, 'U', -1., diag_dssh_dy, 'V', -1.,   &
+         &                  diag_corstrx, 'U', -1., diag_corstry, 'V', -1.,   & 
+         &                  diag_intstrx, 'U', -1., diag_intstry, 'V', -1.    )
 
       CALL lbc_lnk_multi(   diag_utau_oi, 'U', -1., diag_vtau_oi, 'V', -1.    )
 
-      CALL lbc_lnk_multi(   diag_xmtrp_ice, 'U', -1., diag_xmtrp_snw, 'U', -1., &
-                 &          diag_xatrp    , 'U', -1., diag_ymtrp_ice, 'V', -1., &
-                 &          diag_ymtrp_snw, 'V', -1., diag_yatrp    , 'V', -1.  )
+      CALL lbc_lnk_multi(   diag_xmtrp_ice, 'U', -1., diag_xmtrp_snw, 'U', -1.,   &
+         &                  diag_xatrp    , 'U', -1., diag_ymtrp_ice, 'V', -1.,   &
+         &                  diag_ymtrp_snw, 'V', -1., diag_yatrp    , 'V', -1.    )
 
       !
@@ -734,10 +735,8 @@
          CALL prt_ctl_info(charout)
          CALL prt_ctl(tab2d_1=u_ice, clinfo1=' ice_rhg_evp  : u_ice :', tab2d_2=v_ice, clinfo2=' v_ice :')
-      ENDIF
-
-      ! print charge ellipse
-      ! This can be desactivated once the user is sure that the stress state
-      ! lie on the charge ellipse. See Bouillon et al. 08 for more details
-      IF(ln_ctl) THEN
+         !
+         ! print charge ellipse
+         ! This can be desactivated once the user is sure that the stress state
+      ! lie on the charge ellipse. See Bouillon et al. (2008) for more details
          IF( MOD(kt_ice+nn_fsbc-1,nwrite) == 0 ) THEN
             WRITE(charout,FMT="('ice_rhg_evp  :', I4, I6, I1, I1, A10)") 1000, kt_ice, 0, 0, ' ch. ell. '
@@ -760,4 +759,8 @@
    END SUBROUTINE ice_rhg_evp
 
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option         Empty module          NO LIM-3 sea-ice model
+   !!----------------------------------------------------------------------
 #endif
 
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerst.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerst.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icerst.F90	(revision 8486)
@@ -4,11 +4,11 @@
    !! Ice restart :  write the ice restart file
    !!======================================================================
-   !! History:   -   ! 2005-04 (M. Vancoppenolle) Original code
-   !!           3.0  ! 2008-03 (C. Ethe) restart files in using IOM interface
-   !!           4.0  ! 2011-02 (G. Madec) dynamical allocation
+   !! History:   3.0  ! 2005-04 (M. Vancoppenolle) Original code
+   !!             -   ! 2008-03 (C. Ethe) restart files in using IOM interface
+   !!            4.0  ! 2011-02 (G. Madec) dynamical allocation
    !!----------------------------------------------------------------------
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3' :                                   LIM sea-ice model
+   !!   'key_lim3'                                        LIM sea-ice model
    !!----------------------------------------------------------------------
    !!   ice_rst_opn   : open ice restart file
@@ -38,5 +38,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: icerst.F90 8411 2017-08-07 16:09:12Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -123,4 +123,9 @@
       CALL iom_rstput( iter, nitrst, numriw, 'kt_ice' , REAL( iter   , wp ) )      ! date
 
+!!gm   It is possible and easy to define a 3D domain size (jpi,jpj,jpl) or use a SIZE( tab, DIM=3) in iom_rtput )
+!!gm         ===>>> just a simple   iom_rstput( iter, nitrst, numriw, 'v_i', v_i )  etc...
+!!gm   "just" ask Sebatien
+
+
       ! Prognostic variables 
       DO jl = 1, jpl 
@@ -639,9 +644,4 @@
    !!   Default option :       Empty module            NO LIM sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE ice_rst_read             ! Empty routine
-   END SUBROUTINE ice_rst_read
-   SUBROUTINE ice_rst_write            ! Empty routine
-   END SUBROUTINE ice_rst_write
 #endif
 
